//CodeWisionAVR Led/freq_mega8_1/fr1.c
//Chip type   ATmega8   
//Clock frequency F=4,096
// PD4 (TC0)   . 
//  PORTD  PORTB
// CodeVisionAVR C Compiler
// (C) 1998-2004 Pavel Haiduc, HP InfoTech S.R.L.

// I/O registers definitions for the ATmega8


#pragma used+
#pragma used+
sfrb TWBR=0;
sfrb TWSR=1;
sfrb TWAR=2;
sfrb TWDR=3;
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      // 16 bit access
sfrb ADCSRA=6;
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRRL=9;
sfrb UCSRB=0xa;
sfrb UCSRA=0xb;
sfrb UDR=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   // 16 bit access
sfrb UBRRH=0x20;
sfrb UCSRC=0X20;
sfrb WDTCR=0x21;
sfrb ASSR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrw ICR1=0x26;   // 16 bit access
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  // 16 bit access
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  // 16 bit access
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  // 16 bit access
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb SFIOR=0x30;
sfrb OSCCAL=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUCSR=0x34;
sfrb MCUCR=0x35;
sfrb TWCR=0x36;
sfrb SPMCR=0x37;
sfrb TIFR=0x38;
sfrb TIMSK=0x39;
sfrb GIFR=0x3a;
sfrb GICR=0x3b;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

// Interrupt vectors definitions


// Needed by the power management functions (sleep.h)
#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
#endasm


 
//PORTD.0- 1- ;  PORTD.1- 2- 
//PORTD.2--3- ; PORTD.3- 4- 

flash char digits[] =   // 
{0b00111111,  //0  
0b00000110,   //1
0b01011011,   //2
0b01001111,   //3
0b01100110,   //4
0b01101101,   //5
0b01111101,   //6
0b00000111,   //7
0b01111111,   //8
0b01101111    //9 
};

//  
char razrad[4]={0,1,2,3};     //   () LED 
unsigned int indication;      //                   
int ovf=0;                    //ovf=0 -  TCNT0
int freq=0;                   // 
int tis,sot,des,ed,r;
unsigned char num=0;          //   TCNT0      
                              //     1 
void hex_to_dec(void)         //    hex  dec 
{
tis=0;                        //  
while (indication>=1000)      // 
{
indication-=1000;
tis++;
}
sot=0;                        //  
while (indication>=100)       // 
{
indication-=100;
sot++;
}
des=0;                        //  
while (indication>=10)        // 
{
indication-=10;
des++;
}
ed=0;                         //  
while (indication>=1)         // 
{
indication-=1;
ed++;
};
}
//    TCNT0
//     
interrupt [10] timer_0(void)  //    
{
ovf++;  //      TCNT0
};
//    TCNT1
interrupt[9] void timer1_overflow(void) //.  1000  
{
#asm("cli");                   //  
num=TCNT0;                     // TCNT0  1   num                               
freq=(num+ovf*256);            //                     
indication=freq;               //freq .    
                               // indication
//   ,  TCNT1
TCNT1=61536;
TCNT0=0;                          
ovf=0;                             
freq=0;                            
num=0;          
//     
hex_to_dec();
}
//     TCNT2
interrupt[5] void timer2_overflow(void) //
{
r++;                  //
if (r==4) r=0;       
 
 //
switch (razrad[r])    //switch (razrad[r])
    { 
    case 0:           //  
 PORTD=0b1110;
 //PORTD.3=1;           //1 
 //PORTD.2=1;           //1 
 //PORTD.1=1;           //1 
 //PORTD.0=0;           //0            
 PORTB=digits[tis];   //     
   break;
      
    case 1:            //  
 PORTD.0=1;            //1 
 PORTD.1=0;            //0 
 PORTD.2=1;            //1 
 PORTD.3=1;            //1      
 PORTB=digits[sot];    //    
    break; 
 
    case 2:            //  
 PORTD.0=1;            //1   
 PORTD.1=1;            //1  
 PORTD.2=0;            //0 
 PORTD.3=1;            //1   
 PORTB=digits[des];    // 
    break;
    
    case 3:            //  
 PORTD.0=1;            //1 
 PORTD.1=1;            //1 
 PORTD.2=1;            //1 
 PORTD.3=0;            //0 
 PORTB=digits[ed];     //
  break;
    };
};

void main(void)
{                     
//   / 
// Port B initialization  
PORTB=0b00000000;   //  .
DDRB=0b11111111;    //   

// Port C initialization
PORTC=0b00000000;   //  .
DDRC=0b11111110;    //PC0     

// Port D initialization  
PORTD=0b00000000;   //  .
DDRD=0b11101111;    //PD4 , .  

TIMSK =0b01000101;    //  c334 ATmega
//0 bit-    TCNT0 
//2 bit-    TCNT1
//6 bit-    TCNT2

// TCNT0     PD4/T0
//TCNT0   
TCCR0=0b00000111;     //(111)  0,  
//   AVRStudio  101 k=1024 f=F/1024=4000

// TCNT1
//TCNT1     1000 61536   
TCNT1=61536;         //=65536   
//  TCNT1   TCCR1B
TCCR1B = 0b00000101;   //0b00000101 F/1024  373 ATmega

// TCNT2 
//   r     500
TCCR2=0b00000100;     // 4  352 ATmega  100-F/256=16000

#asm("sei");        //              
while(1) {}         //                
}            
