//CodeWisionAVR Led/freq_mega8_1/fr1.c
//Chip type   ATmega8
//Clock frequency F=4,096
// PD4 (TC0)   . 
//  PORTD  PORTB
#include <mega8.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

//PORTD.0- 1- ;  PORTD.1- 2- 
//PORTD.2--3- ; PORTD.3- 4- 

flash char digits[] =   // 
{0b00111111,  //0
0b00000110,   //1
0b01011011,   //2
0b01001111,   //3
0b01100110,   //4
0b01101101,   //5
0b01111101,   //6
0b00000111,   //7
0b01111111,   //8
0b01101111    //9
};

//  
char razrad[4]={0,1,2,3};     //   () LED
unsigned int indication;      //    
int ovf=0;                    //ovf=0 -  TCNT0
int freq=0;                   // 
int tis,sot,des,ed,r;
unsigned char num=0;          //   TCNT0
                              //     1 
void hex_to_dec(void)         //    hex  dec
{
tis=0;                        //  
while (indication>=1000)      // 
{
indication-=1000;
tis++;
}
sot=0;                        //  
while (indication>=100)       // 
{
indication-=100;
sot++;
}
des=0;                        //  
while (indication>=10)        // 
{
indication-=10;
des++;
}
ed=0;                         //  
while (indication>=1)         // 
{
indication-=1;
ed++;
};
}
//    TCNT0
//     
interrupt [TIM0_OVF] timer_0(void)  //
{
ovf++;  //      TCNT0
};
//    TCNT1
interrupt[TIM1_OVF] void timer1_overflow(void) //.  1000
{
#asm("cli");                   //  
num=TCNT0;                     // TCNT0  1   num
freq=(num+ovf*256);            //  
indication=freq;               //freq .    
                               // indication
//   ,  TCNT1
TCNT1=61536;
TCNT0=0;
ovf=0;
freq=0;
num=0;
//    
hex_to_dec();
}
//     TCNT2
interrupt[TIM2_OVF] void timer2_overflow(void) //
{
r++;                  //
if (r==4) r=0;

 //
switch (razrad[r])    //switch (razrad[r])
    {
    case 0:           //  
 PORTD=0b1110;
 //PORTD.3=1;           //1 
 //PORTD.2=1;           //1 
 //PORTD.1=1;           //1 
 //PORTD.0=0;           //0 
 PORTB=digits[tis];   //
   break;

    case 1:            //  
 PORTD.0=1;            //1 
 PORTD.1=0;            //0 
 PORTD.2=1;            //1 
 PORTD.3=1;            //1 
 PORTB=digits[sot];    //
    break;

    case 2:            //  
 PORTD.0=1;            //1 
 PORTD.1=1;            //1 
 PORTD.2=0;            //0 
 PORTD.3=1;            //1 
 PORTB=digits[des];    //
    break;

    case 3:            //  
 PORTD.0=1;            //1 
 PORTD.1=1;            //1 
 PORTD.2=1;            //1 
 PORTD.3=0;            //0 
 PORTB=digits[ed];     //
  break;
    };
};

void main(void)
{
//   /
// Port B initialization
PORTB=0b00000000;   //  .
DDRB=0b11111111;    //   

// Port C initialization
PORTC=0b00000000;   //  .
DDRC=0b11111110;    //PC0     

// Port D initialization
PORTD=0b00000000;   //  .
DDRD=0b11101111;    //PD4 , .  

TIMSK =0b01000101;    //  c334 ATmega
//0 bit-    TCNT0
//2 bit-    TCNT1
//6 bit-    TCNT2

// TCNT0     PD4/T0
//TCNT0   
TCCR0=0b00000111;     //(111)  0,  
//   AVRStudio  101 k=1024 f=F/1024=4000

// TCNT1
//TCNT1     1000 61536
TCNT1=61536;         //=65536
//  TCNT1   TCCR1B
TCCR1B = 0b00000101;   //0b00000101 F/1024  373 ATmega

// TCNT2
//   r     500
TCCR2=0b00000100;     // 4  352 ATmega  100-F/256=16000

#asm("sei");        // 
while(1) {}         // 
}
